hdu 4870 평가(확률 dp)

4573 단어 dp동적 계획ACM
http://acm.hdu.edu.cn/showproblem.php?pid=4870
Rating
Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 433    Accepted Submission(s): 276 Special Judge
Problem Description
A little girl loves programming competition very much. Recently, she has found a new kind of programming competition named "TopTopTopCoder". Every user who has registered in "TopTopTopCoder" system will have a rating, and the initial value of rating equals to zero. After the user participates in the contest held by "TopTopTopCoder", her/his rating will be updated depending on her/his rank. Supposing that her/his current rating is X, if her/his rank is between on 1-200 after contest, her/his rating will be min(X+50,1000). Her/His rating will be max(X-100,0) otherwise. To reach 1000 points as soon as possible, this little girl registered two accounts. She uses the account with less rating in each contest. The possibility of her rank between on 1 - 200 is P for every contest. Can you tell her how many contests she needs to participate in to make one of her account ratings reach 1000 points?
 
Input
There are several test cases. Each test case is a single line containing a float number P (0.3 <= P <= 1.0). The meaning of P is described above.
 
Output
You should output a float number for each test case, indicating the expected count of contest she needs to participate in. This problem is special judged. The relative error less than 1e-5 will be accepted.
 
Sample Input

   
   
   
   
1.000000 0.814700

 
Sample Output

   
   
   
   
39.000000 82.181160

 
Author
FZU
 
Source
2014 Multi-University Training Contest 1
 
저 는 아직 이 dp 를 잘 이해 하지 못 했 습 니 다.대신 의 문제 풀이 보고 서 를 옮 겨 놓 고 나중에 다시 연구 하 겠 습 니 다.
제목:한 여자 가 경 기 를 하 는데 매번 경기 결과 가 200 위 안에 들 면 그녀의 rating 에 50 점 을 더 할 수 있다.그렇지 않 으 면 100 점(rating 최소 0,최대 1000--200 위 안에 들 수 있 는 확률 은 p)이 간다.1000 점 을 달성 하기 위해 이 여자 아 이 는 두 개의 계 정 으로 경 기 를 하고 매번 rating 이 낮은 계 정 으로 경 기 를 하 며 한 개의 계 정 rating 이 1000 에 이 를 때 까지 경 기 를 한다.마지막 으로 경기 장 수 를 진행 해 야 한 다 는 기대 치 를 p 로 정 합 니 다.
문제 풀이:우선 우리 가 생각 하 는 것 은 공식 을 푸 는 것 이다.dp[i]로 i*50-(i+1)*50 의 기대 치 를 대표 한다.dp[0]와 dp[1]는 따로 처리 해 야 합 니 다.
            dp[0]은 우리 가 0-50 에서 진행 해 야 할 장 수 를 대표 하고 두 가지 상황 으로 나 뉜 다.1.성공,확률 p,기대 1*p
                                                                                                              2.실패,확률 1-p,기대(1-p)*(1+dp[0]) 
                                                                                                                -----그래서 dp[0]=1*p+(1-p)*(1+dp[0]),간소화 후 dp[0]=1/p;
            dp[1]은 우리 가 50-100 의 경기 기대 에서 두 가지 상황 으로 나 누 는 것 을 대표 한다.1.성공,확률 은 p 이 고 기 대 는 1*p 이다.
                                                                                                           2.실패,확률 1-p,기대(1-p)*(1+dp[0]+dp[1])  
                                                                                                                -----따라서 dp[1]=1*p+(1-p)*(1+dp[0]+dp[1]),간소화 후 dp[1]=1+(1-p)/p*(1+dp[0]);
            i>2,dp[i]의 구법 은 두 가지 상황 으로 나 뉜 다.1.성공,확률 은 p 이 고 기 대 는 1*p 이다.
                                                                       2.실패,확률 1-p,기대(1-p)*(1+dp[i-2]+dp[i-1]+dp[i])  
                                                                        -----따라서 dp[1]=1*p+(1-p)*(1+dp[0]+dp[1]),간소화 후 dp[1]=1+(1-p)/p*(1+dp[i-2]+dp[-1]);
이렇게 해서 두 개의 계 정 으로 경 기 를 해 야 하기 때문에 우리 가 마지막 으로 도착 한 상 태 는 하나의 계 정 rating=1000 이 고 다른 하 나 는=950 이 며 dp 구 화 를 진행 하면 됩 니 다.
그리고 이 문제 도 고 스 소원 으로 풀 수 있어 요.지금 은 못 해 요.공부 하고 있어 요.
#include<iostream>
#include<algorithm>
#include<stdio.h>
#include<string.h>
#include<set>
#include<queue>
using namespace std;
#define nn 110000
typedef long long LL;
double p;
double dp[30];
int main()
{
    while(cin>>p)
    {
        double sum=0;
        dp[0]=1/p;
        dp[1]=1/(p*p);
        sum=dp[0]+dp[1];
        int i;
        for(i=2;i<=19;i++)
        {
            dp[i]=1+(1-p)/p*(1+dp[i-2]+dp[i-1]);
            sum+=dp[i];
        }
        printf("%.6lf
",sum+sum-dp[19]); } return 0; }

기다리다

좋은 웹페이지 즐겨찾기